Index: trunk/MagicSoft/Mars/mcalib/MCalibColorSet.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibColorSet.cc	(revision 5661)
+++ trunk/MagicSoft/Mars/mcalib/MCalibColorSet.cc	(revision 5677)
@@ -202,4 +202,5 @@
   
   Int_t color = kNONE;
+  fPattern = 0;
 
   switch (num)
@@ -313,105 +314,105 @@
 
       // Possible green combinations
-      TRegexp gre0("0.1led[sS]?[gG][rR][eE][eE]");
+      TRegexp gre0("0.1led[sS]?gree");
       if (proj.Contains(gre0))
         { fPattern |= k01LedGreen; color = kGREEN;    }
-      TRegexp gre1("1led[sS]?[gG][rR][eE][eE]");
+      TRegexp gre1("1led[sS]?gree");
       if (proj.Contains(gre1))
         { fPattern |= k1LedGreen; color = kGREEN;    }
-      TRegexp gre2("2led[sS]?[gG][rR][eE][eE]");
+      TRegexp gre2("2led[sS]?gree");
       if (proj.Contains(gre2))
         { fPattern |= k2LedGreen; color = kGREEN;    }
-      TRegexp gre3("3led[sS]?[gG][rR][eE][eE]");
+      TRegexp gre3("3led[sS]?gree");
       if (proj.Contains(gre3))
         { fPattern |= k3LedGreen; color = kGREEN;    }
-      TRegexp gre5("5led[sS]?[gG][rR][eE][eE]");
+      TRegexp gre5("5led[sS]?gree");
       if (proj.Contains(gre5))
         { fPattern |= k5LedGreen; color = kGREEN;    }
-      TRegexp gre6("6led[sS]?[gG][rR][eE][eE]");
+      TRegexp gre6("6led[sS]?gree");
       if (proj.Contains(gre6))
         { fPattern |= k6LedGreen; color = kGREEN;    }
-      TRegexp gre7("7led[sS]?[gG][rR][eE][eE]");
+      TRegexp gre7("7led[sS]?gree");
       if (proj.Contains(gre7))
         { fPattern |= k7LedGreen; color = kGREEN;    }
-      TRegexp gre8("8led[sS]?[gG][rR][eE][eE]");
+      TRegexp gre8("8led[sS]?gree");
       if (proj.Contains(gre8))
         { fPattern |= k8LedGreen; color = kGREEN;    }
 
       // Possible blue combinations
-      TRegexp blu0("0.1led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu0("0.1led[sS]?blue");
       if (proj.Contains(blu0))
         { fPattern |= k01LedBlue; color = kBLUE;    }
-      TRegexp blu1("1led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu1("1led[sS]?blue");
       if (proj.Contains(blu1))
         { fPattern |= k1LedBlue; color = kBLUE;    }
-      TRegexp blu2("2led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu2("2led[sS]?blue");
       if (proj.Contains(blu2))
         { fPattern |= k2LedBlue; color = kBLUE;    }
-      TRegexp blu3("3led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu3("3led[sS]?blue");
       if (proj.Contains(blu3))
         { fPattern |= k3LedBlue; color = kBLUE;    }
-      TRegexp blu5("5led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu5("5led[sS]?blue");
       if (proj.Contains(blu5))
         { fPattern |= k5LedBlue1; color = kBLUE;    }
-      TRegexp blu6("6led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu6("6led[sS]?blue");
       if (proj.Contains(blu6))
         { fPattern |= k6LedBlue; color = kBLUE;    }
-      TRegexp blu7("7led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu7("7led[sS]?blue");
       if (proj.Contains(blu7))
         { fPattern |= k7LedBlue; color = kBLUE;    }
-      TRegexp blu8("8led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu8("8led[sS]?blue");
       if (proj.Contains(blu8))
         { fPattern |= k8LedBlue; color = kBLUE;    }
-      TRegexp blu10("10led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu10("10led[sS]?blue");
       if (proj.Contains(blu10))
         { fPattern |= k10LedBlue; color = kBLUE;    }
-      TRegexp blu15("15led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu15("15led[sS]?blue");
       if (proj.Contains(blu15))
         { fPattern |= k15LedBlue; color = kBLUE;    }
-      TRegexp blu20("20led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu20("20led[sS]?blue");
       if (proj.Contains(blu20))
         { fPattern |= k20LedBlue; color = kBLUE;    }
-      TRegexp blu21("21led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu21("21led[sS]?blue");
       if (proj.Contains(blu21))
         { fPattern |= k21LedBlue; color = kBLUE;    }
-      TRegexp blu22("22led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu22("22led[sS]?blue");
       if (proj.Contains(blu22))
         { fPattern |= k22LedBlue; color = kBLUE;    }
-      TRegexp blu23("23led[sS]?[bB][lL][uU][eE]");
+      TRegexp blu23("23led[sS]?blue");
       if (proj.Contains(blu23))
         { fPattern |= k23LedBlue; color = kBLUE;    }
 
       // Possible UV combinations
-      TRegexp uv1("1led[sS]?[U][vV]");
+      TRegexp uv1("1led[sS]?uv");
       if (proj.Contains(uv1))
         { fPattern |= k1LedUV; color = kUV;    }
-      TRegexp uv2("2led[sS]?[U][vV]");
+      TRegexp uv2("2led[sS]?uv");
       if (proj.Contains(uv2))
         { fPattern |= k2LedUV; color = kUV;    }
-      TRegexp uv3("3led[sS]?[U][vV]");
+      TRegexp uv3("3led[sS]?uv");
       if (proj.Contains(uv3))
         { fPattern |= k3LedUV; color = kUV;    }
-      TRegexp uv5("5led[sS]?[U][vV]");
+      TRegexp uv5("5led[sS]?uv");
       if (proj.Contains(uv5))
         { fPattern |= k5LedUV1; color = kUV;    }
-      TRegexp uv6("6led[sS]?[U][vV]");
+      TRegexp uv6("6led[sS]?uv");
       if (proj.Contains(uv6))
         { fPattern |= k6LedUV; color = kUV;    }
-      TRegexp uv7("7led[sS]?[U][vV]");
+      TRegexp uv7("7led[sS]?uv");
       if (proj.Contains(uv7))
         { fPattern |= k7LedUV; color = kUV;    }
-      TRegexp uv8("8led[sS]?[U][vV]");
+      TRegexp uv8("8led[sS]?uv");
       if (proj.Contains(uv8))
         { fPattern |= k8LedUV; color = kUV;    }
-      TRegexp uv10("10led[sS]?[U][vV]");
+      TRegexp uv10("10led[sS]?uv");
       if (proj.Contains(uv10))
         { fPattern |= k10LedUV; color = kUV;    }
-      TRegexp uv11("11led[sS]?[U][vV]");
+      TRegexp uv11("11led[sS]?uv");
       if (proj.Contains(uv11))
         { fPattern |= k11LedUV; color = kUV;    }
-      TRegexp uv12("12led[sS]?[U][vV]");
+      TRegexp uv12("12led[sS]?uv");
       if (proj.Contains(uv12))
         { fPattern |= k12LedUV; color = kUV;    }
-      TRegexp uv13("13led[sS]?[U][vV]");
+      TRegexp uv13("13led[sS]?uv");
       if (proj.Contains(uv13))
         { fPattern |= k13LedUV; color = kUV;    }