Index: trunk/MagicSoft/Mars/mcalib/MCalibrationBlindPix.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrationBlindPix.cc	(revision 5384)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrationBlindPix.cc	(revision 5701)
@@ -62,4 +62,5 @@
 
 using namespace std;
+
 const Float_t MCalibrationBlindPix::fgArea       = 100;
 const Float_t MCalibrationBlindPix::fgAttGreen   = 1.97;
@@ -81,4 +82,5 @@
 const Float_t MCalibrationBlindPix::fgCollEffCT1   = 0.90; 
 const Float_t MCalibrationBlindPix::fgCollEffErr   = 0.05; 
+
 // --------------------------------------------------------------------------
 //
@@ -226,5 +228,5 @@
   pix.fPixId      = fPixId;
   pix.fFlags      = fFlags;
-  pix.fArea       = fArea;                     
+  pix.fArea       = fArea;
   pix.fAreaErr    = fAreaErr;                     
   pix.fColor      = fColor;
@@ -233,26 +235,26 @@
   // Copy arrays
   //
-  pix.fAtt        = fAtt;   
-  pix.fAttErr     = fAttErr;            
-  pix.fQE         = fQE;                       
-  pix.fQEErr      = fQEErr;                    
-  pix.fCollEff    = fCollEff;                  
-  pix.fCollEffErr = fCollEffErr;               
- 
-  pix.fLambda                  = fLambda;                   
-  pix.fLambdaCheck             = fLambdaCheck;              
-  pix.fLambdaCheckErr          = fLambdaCheckErr;           
-  pix.fLambdaVar               = fLambdaVar;                
-  pix.fFluxInsidePlexiglass    = fFluxInsidePlexiglass;     
-  pix.fFluxInsidePlexiglassVar = fFluxInsidePlexiglassVar;  
-  pix.fMu0       = fMu0;                      
-  pix.fMu0Err    = fMu0Err;                   
-  pix.fMu1       = fMu1;                      
-  pix.fMu1Err    = fMu1Err;                   
-  pix.fSigma0    = fSigma0;                   
-  pix.fSigma0Err = fSigma0Err;                
-  pix.fSigma1    = fSigma1;                   
-  pix.fSigma1Err = fSigma1Err;                
- 
+  pix.fAtt        = fAtt;
+  pix.fAttErr     = fAttErr;
+  pix.fQE         = fQE;
+  pix.fQEErr      = fQEErr;
+  pix.fCollEff    = fCollEff;
+  pix.fCollEffErr = fCollEffErr;
+
+  pix.fLambda                  = fLambda;
+  pix.fLambdaCheck             = fLambdaCheck;
+  pix.fLambdaCheckErr          = fLambdaCheckErr;
+  pix.fLambdaVar               = fLambdaVar;
+  pix.fFluxInsidePlexiglass    = fFluxInsidePlexiglass;
+  pix.fFluxInsidePlexiglassVar = fFluxInsidePlexiglassVar;
+  pix.fMu0       = fMu0;
+  pix.fMu0Err    = fMu0Err;
+  pix.fMu1       = fMu1;
+  pix.fMu1Err    = fMu1Err;
+  pix.fSigma0    = fSigma0;
+  pix.fSigma0Err = fSigma0Err;
+  pix.fSigma1    = fSigma1;
+  pix.fSigma1Err = fSigma1Err;
+
 }
 
@@ -523,6 +525,6 @@
 
   *fLog << inf << GetDescriptor() 
-        << ": Blind Pixel Nr. " << fPixId << ": Photon flux [ph/mm^2] inside Plexiglass: " 
-        << Form("%5.3f%s%5.3f",fFluxInsidePlexiglass," +- ",GetFluxInsidePlexiglassErr()) << endl;
+      << ": BlindPix #" << fPixId << ": Flux [ph/mm^2] inside Plexiglass: "
+      << Form("%5.3f +- %5.3f",fFluxInsidePlexiglass, GetFluxInsidePlexiglassErr()) << endl;
 
   return kTRUE;
@@ -533,27 +535,18 @@
   
   *fLog << all << GetDescriptor() 
-        << Form("%s%3i","BlindPixel: "       ,GetPixId())
-        << Form("%s%4.2f%s%4.2f","  Lambda: ",GetLambda(),"+-",GetLambdaErr())
-        << Form("%s%4.2f%s%4.2f","  Mu0: "   ,GetMu0(),   "+-",GetMu0Err())
-        << Form("%s%4.2f%s%4.2f","  Mu1: "   ,GetMu1(),   "+-",GetMu1Err()) 
-        << Form("%s%4.2f%s%4.2f","  Sigma0: ",GetSigma0(),"+-",GetSigma0Err())
-        << Form("%s%4.2f%s%4.2f","  Sigma1: ",GetSigma1(),"+-",GetSigma1Err())
+        << Form("BlindPixel: %3i"         ,GetPixId())
+        << Form("  Lambda: %4.2f +- %4.2f",GetLambda(),GetLambdaErr())
+        << Form("  Mu0: %4.2f +- %4.2f"   ,GetMu0(),   GetMu0Err())
+        << Form("  Mu1: %4.2f +- %4.2f"   ,GetMu1(),   GetMu1Err())
+        << Form("  Sigma0: %4.2f +- %4.2f",GetSigma0(),GetSigma0Err())
+        << Form("  Sigma1: %4.2f +- %4.2f",GetSigma1(),GetSigma1Err())
         << endl;
   *fLog << all
         << " Pedestal Fit OK? :" << IsPedestalFitOK() 
-        << Form("%s%4.2f%s%4.2f","  Lambda (Check): " ,GetLambdaCheck(),"+-",GetLambdaCheckErr()) 
+        << Form("  Lambda (Check): %4.2f +- %4.2f",GetLambdaCheck(),GetLambdaCheckErr())
         << endl;
   *fLog << all
         << " Flux available? :" << IsFluxInsidePlexiglassAvailable() 
-        << Form("%s%4.2f%s%4.2f","  Flux: " ,GetFluxInsidePlexiglass(),"+-",GetFluxInsidePlexiglassErr())
+        << Form("  Flux: %4.2f +- %4.2f",GetFluxInsidePlexiglass(),GetFluxInsidePlexiglassErr())
         << endl;
 }
-
-
-
-
-
-
-
-
-