Index: trunk/MagicSoft/Mars/Changelog
===================================================================
--- trunk/MagicSoft/Mars/Changelog	(revision 5732)
+++ trunk/MagicSoft/Mars/Changelog	(revision 5734)
@@ -27,4 +27,9 @@
        saturation, then. Important for high-intensity calibration events.
 
+
+   * msignal/MExtractor.cc
+   * msignal/MExtractTime.cc
+   * msignal/MExtractTimeAndCharge.cc
+     - added some documentation
 
 
Index: trunk/MagicSoft/Mars/msignal/MExtractTime.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTime.cc	(revision 5732)
+++ trunk/MagicSoft/Mars/msignal/MExtractTime.cc	(revision 5734)
@@ -30,4 +30,16 @@
 //   FindTimeHiGain() and FindTimeLoGain() to extract the signal and 
 //   substract the pedestal value    
+//
+//   The following figure gives and example of possible inheritance trees. 
+//   An extractor class can inherit from each of the following base classes:
+//    - MExtractor
+//    - MExtractTime
+//    - MExtractTimeAndCharge
+//
+//Begin_Html
+/*
+<img src="images/ExtractorClasses.gif">
+*/
+//End_Html
 //
 //   The following variables have to be set by the derived class and 
@@ -137,16 +149,4 @@
 }
 
-void MExtractTime::FindTimeHiGain(Byte_t *firstused, Float_t &time, Float_t &dtime, 
-                                  Byte_t &sat, const MPedestalPix &ped) const
-{
-  return;
-}
-
-void MExtractTime::FindTimeLoGain(Byte_t *firstused, Float_t &time, Float_t &dtime, 
-                                  Byte_t &sat, const MPedestalPix &ped) const
-{
-  return;
-}
-
 // --------------------------------------------------------------------------
 //
Index: trunk/MagicSoft/Mars/msignal/MExtractTime.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTime.h	(revision 5732)
+++ trunk/MagicSoft/Mars/msignal/MExtractTime.h	(revision 5734)
@@ -19,7 +19,7 @@
   
   virtual void FindTimeHiGain(Byte_t *firstused, Float_t &time, Float_t &dtime,
-                              Byte_t &sat, const MPedestalPix &ped) const;
+                              Byte_t &sat, const MPedestalPix &ped) const {}
   virtual void FindTimeLoGain(Byte_t *firstused, Float_t &time, Float_t &dtime,
-                              Byte_t &sat, const MPedestalPix &ped) const;
+                              Byte_t &sat, const MPedestalPix &ped) const {}
 
   Int_t  PreProcess( MParList *pList );
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc	(revision 5732)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc	(revision 5734)
@@ -32,4 +32,16 @@
 //   substract the pedestal value.
 //
+//   The following figure gives and example of possible inheritance trees. 
+//   An extractor class can inherit from each of the following base classes:
+//    - MExtractor
+//    - MExtractTime
+//    - MExtractTimeAndCharge
+//
+//Begin_Html
+/*
+<img src="images/ExtractorClasses.gif">
+*/
+//End_Html
+//
 //   The following variables have to be set by the derived class and 
 //   do not have defaults:
Index: trunk/MagicSoft/Mars/msignal/MExtractor.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractor.cc	(revision 5732)
+++ trunk/MagicSoft/Mars/msignal/MExtractor.cc	(revision 5734)
@@ -22,5 +22,4 @@
 !
 \* ======================================================================== */
-
 //////////////////////////////////////////////////////////////////////////////
 //
@@ -53,4 +52,15 @@
 //      calculate the pure noise contriubtion from a fixed window in time.
 //
+// The following figure gives and example of possible inheritance trees. 
+// An extractor class can inherit from each of the following base classes:
+//    - MExtractor
+//    - MExtractTime
+//    - MExtractTimeAndCharge
+//
+//Begin_Html
+/*
+<img src="images/ExtractorClasses.gif">
+*/
+//End_Html
 //
 // Input Containers:
@@ -270,4 +280,5 @@
 Int_t MExtractor::Process()
 {
+
   MRawEvtPixelIter pixel(fRawEvt);
   fSignals->Clear();