Index: trunk/MagicSoft/Mars/mtemp/mifae/Changelog
===================================================================
--- trunk/MagicSoft/Mars/mtemp/mifae/Changelog	(revision 5675)
+++ trunk/MagicSoft/Mars/mtemp/mifae/Changelog	(revision 5775)
@@ -19,4 +19,8 @@
                                                  -*-*- END OF LINE -*-*-
 
+ 2005/01/10 Javier Rico
+    * programs/makeHillas, programs/makehillas.datacard
+     - adapt to new mars version
+	
  2004/12/22 Eva Domingo
     * library/MImageParDisp.[cc,h]
Index: trunk/MagicSoft/Mars/mtemp/mifae/programs/Makefile
===================================================================
--- trunk/MagicSoft/Mars/mtemp/mifae/programs/Makefile	(revision 5675)
+++ trunk/MagicSoft/Mars/mtemp/mifae/programs/Makefile	(revision 5775)
@@ -18,5 +18,6 @@
 include ../../../Makefile.conf.general
 
-PROGRAMS = makeHillas psffit falseSource srcPos optimizeCuts  controlPlot
+PROGRAMS = makeHillas
+#psffit falseSource srcPos optimizeCuts  controlPlot
 SOLIB    = $(MARSSYS)/libmars.so
 
Index: trunk/MagicSoft/Mars/mtemp/mifae/programs/makeHillas.cc
===================================================================
--- trunk/MagicSoft/Mars/mtemp/mifae/programs/makeHillas.cc	(revision 5675)
+++ trunk/MagicSoft/Mars/mtemp/mifae/programs/makeHillas.cc	(revision 5775)
@@ -6,4 +6,6 @@
 #include "TArrayS.h"
 
+#include "MArray.h"
+#include "MParContainer.h"
 #include "MParList.h"
 #include "MTaskList.h"
@@ -34,4 +36,5 @@
 #include "MCerPhotEvt.h"
 #include "MPedPhotCam.h"
+#include "MArrivalTime.h"
 #include "MCalibrateData.h"
 #include "MPedPhotCalc.h"
@@ -60,4 +63,5 @@
 
 #include "TApplication.h"
+#include "TClass.h"
 
 #include <iostream>
@@ -101,5 +105,5 @@
 
 const TString defaultcard="makehillas.datacard";
-char* chext[3]={"Fixed window","Sliding window","Peak Search"};
+char* chext[4]={"Fixed window","Sliding window","Peak Search","Spline"};
 /*************************************************************/
 static void Usage()
@@ -117,4 +121,8 @@
   TApplication app("Application",0,0);
 
+  // to deal correctly with the streamer
+  MArray::Class()->IgnoreTObjectStreamer();
+  MParContainer::Class()->IgnoreTObjectStreamer();
+
   // evaluate arguments
   MArgs arg(argc, argv);
@@ -158,8 +166,8 @@
     case 3:
       extractor = new MExtractTimeAndChargeSpline();
+      ((MExtractTimeAndChargeSpline*)extractor)->SetTimeType(MExtractTimeAndChargeSpline::kHalfMaximum);
       ((MExtractTimeAndChargeSpline*)extractor)->SetChargeType(MExtractTimeAndChargeSpline::kIntegral);      
       ((MExtractTimeAndChargeSpline*)extractor)->SetRiseTime((Float_t)wsize*0.25); 
       ((MExtractTimeAndChargeSpline*)extractor)->SetFallTime((Float_t)wsize*0.75);
-      ((MExtractTimeAndChargeSpline*)extractor)->SetTimeType(MExtractTimeAndChargeSpline::kHalfMaximum);
       break;
     default:
@@ -210,5 +218,5 @@
     }
 
-  MPedestalCam pedcammean = pedloop1.GetPedestalCam();      
+  MPedestalCam& pedcammean = pedloop1.GetPedestalCam();      
   extractor->SetPedestals(&pedcammean);
 
@@ -228,4 +236,7 @@
     if (!calloop.Process(pedcammean))
       return;
+
+  MCalibrationChargeCam &chargecam = calloop.GetCalibrationCam();
+  chargecam.Print();
 
 
@@ -316,5 +327,6 @@
       plist4.AddToList(&tlist4);
       plist4.AddToList(&geomcam);
-      
+      plist4.AddToList(&pedcamrms);
+
       //tasks
       MReadMarsFile read4("Events");
@@ -351,4 +363,5 @@
   MCerPhotEvt     nphot;
   MPedPhotCam     nphotrms;
+  MArrivalTime    arrtime;
   MHillas         hillas;
   MNewImagePar    newimagepar;
@@ -382,4 +395,5 @@
   plist5.AddToList(&nphot);
   plist5.AddToList(&nphotrms);
+  plist5.AddToList(&arrtime);
   plist5.AddToList(&source);
   plist5.AddToList(&hillas);
Index: trunk/MagicSoft/Mars/mtemp/mifae/programs/makehillas.datacard
===================================================================
--- trunk/MagicSoft/Mars/mtemp/mifae/programs/makehillas.datacard	(revision 5675)
+++ trunk/MagicSoft/Mars/mtemp/mifae/programs/makehillas.datacard	(revision 5775)
@@ -11,16 +11,14 @@
 
 // Maximun number of (data) events to be processed)
-NEVENTS 99999999
+NEVENTS 5000
 
 // data file directory
-IDIR /mnt/magic/Data/rootdata/CrabNebula/Period021/2004_09_22/
+IDIR /local_disk/jrico/rawdata/
 
 // Pedestal (PRUNS), calibration (CRUNS) and data runs (DRUNS), e.g 1500-23444,25444,25455-26544
 // if PRUNS 0, take pedestals from low gains
-PCRUNS 39313
-CRUNS  39315
-DRUNS 39261,39262,39264,39265,39269,39271,39273,39274,39276,39277,39279,39280,39282,39283,39285
-//,39286,39288,39290,39292-39294,39296-39299,39301,39302,39304-39306,39308,39309,39311,39318,39319,39321,39322,39324,39325,39327,39328,39330,39331,39333,39334,39336-39338,39340-39342,39344,39348-39350,39352-39355,39357,39358,39360-39362,39364-39366,39368-39370,39372,39373
-// 37478-37480,37482-37484,37486,37487,37489-37491,37493-37495,37497-37499,37501-37502,37504-37505,37507-37508,37510-37512,37514,37516-37519,37521,37522,37524,37525,37527-37529,37531,37532,37534,37535,37537-37539,37541-37544,37546-37551,37553-37555
+PCRUNS 45380
+CRUNS  45419
+DRUNS  45428
 
 // output file name
@@ -54,5 +52,5 @@
 // 11: kDefault(F factor) + bad pixel interpolation
 // 21: kDemocratic + bad pixel interpolation
-CALFLAG 1
+CALFLAG 11
 
 // calibration time: