Index: /trunk/MagicSoft/TDAS-Extractor/Changelog
===================================================================
--- /trunk/MagicSoft/TDAS-Extractor/Changelog	(revision 5780)
+++ /trunk/MagicSoft/TDAS-Extractor/Changelog	(revision 5781)
@@ -22,5 +22,5 @@
 2004/01/08: Markus Gaug
   * Algorithms.tex: text updated and new figures
-
+  * Pedestal.tex: text updated
 
 2005/01/05: Hendrik Bartko
Index: /trunk/MagicSoft/TDAS-Extractor/Pedestal.tex
===================================================================
--- /trunk/MagicSoft/TDAS-Extractor/Pedestal.tex	(revision 5780)
+++ /trunk/MagicSoft/TDAS-Extractor/Pedestal.tex	(revision 5781)
@@ -22,7 +22,5 @@
 can be completely described by the noise-autocorrelation matrix $\boldsymbol{B}$ 
 (eq.~\ref{eq:autocorr}), 
-where the diagonal elements give what is usually denoted as the ``Pedestal RMS''. Note that 
-in the MAGIC readout, the diagonal elements do not scale exactly with the square root of 
-the number of slices as would be expected from pure stochasitic noise. 
+where the diagonal elements give what is usually denoted as the ``Pedestal RMS''. 
 
 \par
@@ -42,5 +40,5 @@
 \end{equation}
 
-has the mean $B$ and the RMS $R$
+has the mean $B$ and the RMS $R$ defined by:
 
 \begin{eqnarray}
@@ -55,15 +53,19 @@
 \end{equation}
 
-$B$ is the bias, $R$ is the RMS of the distribution of $X$ and $D$ is something
+The parameter $B$ can be called the bias of the pedestal extractor and $R$ 
+the RMS of the distribution of $X$ and $D$ is something
 like the (asymmetric) error of $SE$. 
 The distribution of $X$, and thus the parameters $B$ and $R$, 
-depend on the size of $ST$ and the size of the background fluctuations $BG$.
+depend generally on the size of $ST$ and the size of the background fluctuations $BG$.
 
 \par
 
 For the normal image cleaning, knowledge of $B$ is sufficient and the 
-error $R$ should be know in order to calculate a correct background probability.
-\par
-Also for the model analysis $B$ and $R$ are needed, because you want to keep small
+error $R$ should be known in order to calculate a correct background probability.
+
+\par
+\ldots {\textit{\bf THOMAS SCHWEIZER ???}}
+\par
+Also for the model analysis $B$ and $R$ are needed if one wants to keep small
 signals. 
 \par
@@ -72,17 +74,11 @@
 
 \begin{equation}
-\frac{(\Delta ST)^2}{<ST>^2} = \frac{1}{<m_{pe}>} * F^2
+\frac{(\Delta ST)^2}{<ST>^2} = \frac{1}{<n_{phe}>} * F^2
 \end{equation}
 
 Here $\Delta ST$ is the fluctuation of the true signal $ST$ due to the
 fluctuation of the number of photo electrons. $ST$ is obtained from the
-measured fluctuations of $SE$  ($RMS_{SE}$) by subtracting the fluctuation of the
-extracted signal ($R$) due to the fluctuation of the pedestal.
-
-\begin{equation}
- (\Delta ST)^2 = RMS_{SE}^2 - R^2
-\label{eq:rmssubtraction}
-\end{equation}
-
+measured fluctuations of $SE$  ($RMS_{SE}$) by subtracting those fluctuations of the
+extracted signal which are due to the fluctuation of the pedestal ($R$)\footnote{%
 A way to check whether the right RMS has been subtracted is to make the
 Razmick plot
@@ -99,5 +95,10 @@
 \end{equation}
 
-where $c$ is the photon/ADC conversion factor  $<ST>/<m_{pe}>$.
+where $c$ is the photon/ADC conversion factor  $<ST>/<m_{pe}>$.}.
+
+\begin{equation}
+ (\Delta ST)^2 = RMS_{SE}^2 - R^2 
+\label{eq:rmssubtraction}
+\end{equation}
 
 \subsection{How to Retrieve Bias $B$ and Error $R$}
@@ -108,5 +109,5 @@
 \par
 In the case of the optimum filter, $R$ is in theory independent from the 
-signal amplitude $ST$ and depends only on the background $BG$, see eq.~\ref{of_noise}.
+signal amplitude $ST$ and depends only on the background $BG$ (eq.~\ref{of_noise}).
 It can be obtained from the
 fitted error of the extracted signal ($\Delta(SE)_{fitted}$), 
@@ -130,5 +131,5 @@
 \end{enumerate}
 
-\subsubsection{ \label{sec:determiner} Determine Error $R$ by Applying the Signal Extractor to a Fixed Window
+\subsubsection{ \label{sec:determiner} Determine $R$ by Applying the Signal Extractor to a Fixed Window
 of Pedestal Events}
 
@@ -136,12 +137,13 @@
 determined the parameter $R$ for the case of no signal ($ST = 0$). In the case of 
 all extractors using a fixed window from the beginning (extractors nr. \#1 to \#22 
-in section~\ref{sec:algorithms}), the results were exactly the same as calculating 
+in section~\ref{sec:algorithms}), the results are thus by construction the same as calculating 
 the mean and the RMS of a same (fixed) number of FADC slices (the conventional ``Pedestal 
 Calculation'').
 
 \par
-In the case of the amplitude extracting spline (extractor nr. \#27), we took the 
-spline value at a random place within the digitizing binning resolution (0.02 FADC slices) of 
-one central FADC slice. 
+In the case of the amplitude extracting spline (extractor nr. \#23), we placed the 
+spline maximum value (which determines the exact extraction window) at a random place 
+within the digitizing binning resolution (0.01 FADC slices) 
+of one central FADC slice. 
 In the case of the digital filter (extractor nr. \#28), the time shift was  
 randomized for each event within one central FADC slice.
@@ -326,3 +328,4 @@
 %%% TeX-master: "Pedestal"
 %%% TeX-master: "MAGIC_signal_reco"
+%%% TeX-master: "MAGIC_signal_reco."
 %%% End: 